
#include "MacroPatternMatch.h"

#include "HROOTCoreTArrayD.h"

#include "HROOTCoreTNamed.h"

#include "HROOTCoreTAttAxis.h"

#include "TAxis.h"

#include "HROOTHistTAxis.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TNAMED_DEF_VIRT(TAxis)
TATTAXIS_DEF_VIRT(TAxis)
TOBJECT_DEF_VIRT(TAxis)
DELETABLE_DEF_VIRT(TAxis)
TAXIS_DEF_VIRT(TAxis)
TAXIS_DEF_NONVIRT(TAxis)
TAXIS_DEF_ACCESSOR(TAxis)

