
#include "MacroPatternMatch.h"

#include "HROOTHistTGraph.h"

#include "TGraphAsymmErrors.h"

#include "HROOTHistTGraphAsymmErrors.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TGRAPH_DEF_VIRT(TGraphAsymmErrors)
TNAMED_DEF_VIRT(TGraphAsymmErrors)
TATTLINE_DEF_VIRT(TGraphAsymmErrors)
TATTFILL_DEF_VIRT(TGraphAsymmErrors)
TATTMARKER_DEF_VIRT(TGraphAsymmErrors)
TOBJECT_DEF_VIRT(TGraphAsymmErrors)
DELETABLE_DEF_VIRT(TGraphAsymmErrors)
TGRAPHASYMMERRORS_DEF_VIRT(TGraphAsymmErrors)
TGRAPHASYMMERRORS_DEF_NONVIRT(TGraphAsymmErrors)
TGRAPHASYMMERRORS_DEF_ACCESSOR(TGraphAsymmErrors)

